#include <fstream>
#include "Room.h"
using namespace std;

Room::Room(char* filename)
{
	ifstream input(filename);
	int indata;

/* Write code here to read in number of rows and columns 
into variables "rows" and "cols"
from the input file and then read exit location (row and column)
into "row_exit" and "col_exit"
*/


	person_count = 0;
	room = new Person**[rows];
	for(int i=0; i<rows; i++)
	{
		room[i] = new Person*[cols];
		for(int j=0; j<cols; j++)
		{
			input >> indata;
			if(indata == 0)
				room[i][j]=NULL;
			else
			{
				room[i][j]=new Person(i,j,this);
				person_count++;
			}
		}
	}
	time = 0;
	output.open("output.txt");
	PrintRoom();
}

bool Room::isEmpty(int row, int column)
{
//write code for this
}

bool Room::legalSquare(int row, int column)
{
//write code for this
}

bool Room::Occupied(int row, int column)
{
//write code for this
}

void Room::Simulate()
{
	//Initialize # of people still in the room

	int people_left=person_count;

	//Start simulation
	while(people_left > 0)
	{//While people are still in the room
		for(int i=0; i<rows; i++)
		{//For each row
			for(int j=0; j<cols; j++)
			{//For each column
				if((room[i][j]!=NULL) && (room[i][j]->hasMoved() != true))
				{//If room occupied and its person has not been moved

					//Move person
					room[i][j]->Move();

					//If person at exit, remove person from room
					if(room[row_exit][col_exit] != NULL)
					{
						people_left--;
						delete room[row_exit][col_exit];
						room[row_exit][col_exit] = NULL;
					}

					//Increment clock
					time++;
				}
			}
		}
		//Reset everyone to 'not moved'
		//write code for this using function setMoved
		//use a double loop here

			}
		}
		PrintRoom();
	}
}

void Room::addPerson(Person* p, int row, int col)
{
	room[row][col]=p;
}

void Room::removePerson(int row, int col)
{
	room[row][col]=NULL;
}

int Room::exitDistance(int r, int c)
{
//write code for this
}

void Room::PrintRoom()
{
	//Output room information
	output << "Time: " << time << endl
		   << "----------------------" << endl;
	for(int i=0; i<rows; i++)
	{//For each row
		for(int j=0; j<cols; j++)
		{//For each column
			//Output 1 if square occupied, 0 otherwise
			//write code for this

		}
		output << endl;
	}
	output << endl;
}

Room::~Room()
{
	output.close();
	for(int i=0; i<rows; i++)
	{
		delete room[i];
	}
	delete room;
}
